/****
TRO_DYNAMIC_SR3 5:43 AM 9/8/2006 PLOT DYNAMIC SUPPORT/RESISTANCE
 
Programmer:  Avery T. Horton, Jr.  aka TheRumpledOne,  
DONATIONS AND GIFTS ACCEPTED 
P O BOX 43575, TUCSON, AZ 85733 

please include this and/or any other comment blocks and a 
description of any changes you make.
****/
/*
Converted to NeoTicker by Luke
10/25/2006
*/
using System;
using System.Collections.Generic;
using System.Text;
using Interop.NeoTicker;

namespace TheRumpledOne
{
    [System.Security.SuppressUnmanagedCodeSecurity]
    public class TRODynamicSR3 :IDLIndicator
    {
        #region Consts & Variables
        const int heapCount = 16;
        const string
            db = "a1",
            mp = "a2",
            al = "a3",
            rp = "a4",
            ds = "a5",
            ps = "a6",
            os = "a7",
            dr = "a8",
            pr = "a9",
            or = "b1",
            dm = "b2",
            lb = "b3",
            le = "b4",
            se = "b5",
            dc = "b6",
            sh = "b7";

        IItselfObj Itself;
        INTLibObj NTLib;
        IReportObj Report;
        IParamListObj Params;
        IDataObj Data1;
        IHeapObj Pheap;
        INestedIndicatorObj HighI, LowI;

        bool IsDebug
        {
            set { Pheap.set_Int(db, (value) ? 1 : 0); }
            get { return (Pheap.get_Int(db) == 1)?true:false;}
        }
        bool ShowMidpoint
        {
            set { Pheap.set_Int(mp, (value) ? 1 : 0); }
            get { return (Pheap.get_Int(mp) == 1) ? true : false; }
        }
        bool ShowEntries
        {
            set { Pheap.set_Int(sh, (value) ? 1 : 0); }
            get { return (Pheap.get_Int(sh) == 1) ? true : false; }
        }
        bool Alert
        {
            set { Pheap.set_Int(al, (value) ? 1 : 0); }
            get { return (Pheap.get_Int(al) == 1) ? true : false; }
        }
        string sReport
        {
            set { Pheap.set_Str(rp, value); }
            get { return Pheap.get_Str(rp).ToString(); }
        }
        double DynamicS
        {
            set { Pheap.set_Real(ds, value); }
            get { return Pheap.get_Real(ds); }
        }
        double PrevDynamicS
        {
            set { Pheap.set_Real(ps, value); }
            get { return Pheap.get_Real(ps); }
        }
        double OldDynamicS
        {
            set { Pheap.set_Real(os, value); }
            get { return Pheap.get_Real(os); }
        }
        double DynamicR
        {
            set { Pheap.set_Real(dr, value); }
            get { return Pheap.get_Real(dr); }
        }
        double PrevDynamicR
        {
            set { Pheap.set_Real(pr, value); }
            get { return Pheap.get_Real(pr); }
        }
        double OldDynamicR
        {
            set { Pheap.set_Real(or, value); }
            get { return Pheap.get_Real(or); }
        }
        double DynamicM
        {
            set { Pheap.set_Real(dm, value); }
            get { return Pheap.get_Real(dm); }
        }
        double LgEntry
        {
            set { Pheap.set_Real(le, value); }
            get { return Pheap.get_Real(le); }
        }
        double ShEntry
        {
            set { Pheap.set_Real(se, value); }
            get { return Pheap.get_Real(se); }
        }
        int LookbackPeriod
        {
            set { Pheap.set_Int(lb, value); }
            get { return Pheap.get_Int(lb); }
        }
        int Decimals
        {
            set { Pheap.set_Int(dc, value); }
            get { return Pheap.get_Int(dc); }
        }

        #endregion
        double IIDLIndicator.IDLCallEx(NTIndicatorObjects NTIndicatorObjects)
        {
            #region NeoTicker Objects
            Itself = NTIndicatorObjects.ItSelf();
            NTLib = NTIndicatorObjects.NTLib();
            Report = NTIndicatorObjects.Report();
            Params = NTIndicatorObjects.Params();
            Data1 = NTIndicatorObjects.Data1();
            Pheap = NTIndicatorObjects.PHeap();

            #endregion

            #region FirstCall

            if (Itself.FirstCall)
            {
                Pheap.Allocate(heapCount);
                IsDebug = (Params.get_Items("Debug").Str.ToString().ToUpper() == "YES")?true:false;
                Alert = (Params.get_Items("Alert").Str.ToString().ToUpper() == "YES") ? true : false;
                ShowMidpoint = (Params.get_Items("ShowMidpoint").Str.ToString().ToUpper() == "YES") ? true : false;
                ShowEntries = (Params.get_Items("ShowEntries").Str.ToString().ToUpper() == "YES") ? true : false;
                LookbackPeriod = Params.get_Items("SRPeriod").Int;
                Decimals = Params.get_Items("Decimals").Int;

                sReport = Data1.Symbol.ToString() + "_" + Itself.FuncName.ToString();
                if (IsDebug)
                {
                    Report.OpenNew(sReport);
                    Report.Clear(sReport);
                    Report.AddValue(sReport, NTLib.DateTime2Str(NTLib.NTNow()), "Log Init Time");
                    Report.AddLine(sReport, "-----------");
                }
            }

            #endregion

            try
            {
                if (Data1.get_BarsNum(0) ==  1 && Data1.get_Day(0) != Data1.get_Day(1))
                {
                    DynamicR = Data1.get_High(0);
                    DynamicS = Data1.get_Low(0);
                    ShEntry = DynamicR;
                    LgEntry = DynamicS;
                }
            }
            catch (System.Exception)
            {
                DynamicR = Data1.get_High(0);
                DynamicS = Data1.get_Low(0);
                ShEntry = DynamicR;
                LgEntry = DynamicS;
            }
            IndicatorMaintainence();

            OldDynamicR = PrevDynamicR;
            OldDynamicS = PrevDynamicS;

            PrevDynamicR = DynamicR;
            PrevDynamicS = DynamicS;

            DynamicR = Math.Round(HighI.get_Value(0),Decimals);
            DynamicS = Math.Round(LowI.get_Value(0),Decimals);

            if (DynamicR != Data1.get_High(0) && DynamicR < PrevDynamicR && PrevDynamicR != 0)
                DynamicR = PrevDynamicR;
            
            if (DynamicS != Data1.get_Low(0) && DynamicS > PrevDynamicS && PrevDynamicS != 0)
                DynamicS = PrevDynamicS;

            if (Data1.get_High(0) == DynamicR)
                ShEntry = Data1.get_Low(0);
            if (Data1.get_Low(0) == DynamicS)
                LgEntry = Data1.get_High(0);

            Itself.set_Plot(1, DynamicS);
            Itself.set_SuccessEx(1, ((DynamicS!=0) ? true : false));
            Itself.set_Plot(2, DynamicR);
            Itself.set_SuccessEx(2, ((DynamicR != 0) ? true : false));

            if (ShowEntries)
            {
                Itself.set_Plot(4, ShEntry);
                Itself.set_SuccessEx(4, ((ShEntry != 0) ? true : false));
                Itself.set_Plot(5, LgEntry);
                Itself.set_SuccessEx(5, ((LgEntry != 0) ? true : false));
            }
            else
            {
                Itself.set_SuccessEx(4, false);
                Itself.set_SuccessEx(4, false);
            }

            if (ShowMidpoint)
            {
                DynamicM = Math.Round(((DynamicS + DynamicR) *.5),Decimals);
                Itself.set_Plot(3, DynamicM);
                Itself.set_SuccessEx(3, ((DynamicM != 0) ? true : false));
            }
            else
                Itself.set_SuccessEx(3, false);

            if (IsDebug)
                DebugSummary();

            return 0;
        }

        #region Indicator Maintainence
        protected void IndicatorMaintainence()
        {
           
            HighI = Itself.UpdateIndicator("hhv1");
            if (HighI == null)
            {
                HighI = Itself.MakeIndicator("hhv1", "hhv", new string[] { "1.high" }, new string[] { LookbackPeriod.ToString() });
            }
            LowI = Itself.UpdateIndicator("llv1");
            if (LowI == null)
            {
                LowI = Itself.MakeIndicator("llv1", "llv", new string[] { "1.low" }, new string[] { LookbackPeriod.ToString() });
            }
        }
        #endregion

        #region General
        protected void DebugSummary()
        {
            WriteReportLine( "DYNAMIC SUPPORT:    " + DynamicS );
            WriteReportLine( "LOW:                " + Data1.get_Low(0)); 
            WriteReportLine( "PrevDynamic_S:      " + PrevDynamicS);
            WriteReportLine( "xLL:                " + LowI.get_Value(0)); 

            WriteReportLine( "DYNAMIC RESISTANCE: " + DynamicR ); 
            WriteReportLine( "HIGH:               " + Data1.get_High(0));
            WriteReportLine( "PrevDynamic_R:      " + PrevDynamicR ); 
            WriteReportLine( "xHH:                " + HighI.get_Value(0));

            WriteReportLine(NTLib.DateTime2Str(NTLib.NTNow()).ToString());
            WriteReportLine( "------- TRO_DYNAMIC_SR2 ---------");
        }

        protected void WriteReportLine(string RptMsg)
        {
            if (IsDebug)
                Report.AddLine(sReport, RptMsg);
        }

        #endregion
    }
}
